/* DO NOT EDIT THIS FILE - it is machine generated */
#include   <jni.h>
#include   <stdio.h>    
#include   <stdlib.h>  
#include   <unistd.h>    
#include   <sys/types.h>
#include   <sys/stat.h> 
#include   <fcntl.h>   
#include   <termios.h> 
#include   <errno.h>   
#include   <string.h>
#include   "android/log.h"
static const char *TAG="serialport_jni";
#define LOGI(fmt, args...) __android_log_print(ANDROID_LOG_INFO,  TAG, fmt, ##args)
#define LOGD(fmt, args...) __android_log_print(ANDROID_LOG_DEBUG, TAG, fmt, ##args)
#define LOGE(fmt, args...) __android_log_print(ANDROID_LOG_ERROR, TAG, fmt, ##args)
/* Header for class cn_geomobile_lfrfid_serial_native */

#ifndef _Included_cn_geomobile_lfrfid_serial_native
#define _Included_cn_geomobile_lfrfid_serial_native
#ifdef __cplusplus
extern "C" {
#endif
/*
 * Class:     cn_geomobile_lfrfid_serial_native
 * Method:    open_serial
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_cn_geomobile_lfrfid_serial_1native_open_1serial
  (JNIEnv *, jobject, jstring);

/*
 * Class:     cn_geomobile_lfrfid_serial_native
 * Method:    close_serial
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_cn_geomobile_lfrfid_serial_1native_close_1serial
  (JNIEnv *, jobject, jint);

/*
 * Class:     cn_geomobile_lfrfid_serial_native
 * Method:    try_write
 * Signature: (I[B)I
 */
JNIEXPORT jint JNICALL Java_cn_geomobile_lfrfid_serial_1native_try_1write
  (JNIEnv *, jobject, jint, jbyteArray);

/*
 * Class:     cn_geomobile_lfrfid_serial_native
 * Method:    try_read
 * Signature: (III)[B
 */
JNIEXPORT jbyteArray JNICALL Java_cn_geomobile_lfrfid_serial_1native_try_1read
  (JNIEnv *, jobject, jint, jint, jint);

/*
 * Class:     cn_geomobile_lfrfid_serial_native
 * Method:    drop_data
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_cn_geomobile_lfrfid_serial_1native_drop_1data
  (JNIEnv *, jobject, jint);

#ifdef __cplusplus
}
#endif
#endif
static void setTermios(struct termios * pNewtio, int uBaudRate)
{
	bzero(pNewtio, sizeof(struct termios)); /* clear struct for new port settings */
	//8N1
	pNewtio->c_cflag = uBaudRate | CS8 | CREAD | CLOCAL | CSTOPB;
	pNewtio->c_iflag = IGNPAR;
	pNewtio->c_oflag = 0;
	pNewtio->c_lflag = 0; //non ICANON

	/*

	   initialize all control characters

	   default values can be found in /usr/include/termios.h, and

	   are given in the comments, but we don't need them here

*/

	pNewtio->c_cc[VINTR] = 0; /* Ctrl-c */
	pNewtio->c_cc[VQUIT] = 0; /* Ctrl-\ */
	pNewtio->c_cc[VERASE] = 0; /* del */
	pNewtio->c_cc[VKILL] = 0; /* @ */
	pNewtio->c_cc[VEOF] = 4; /* Ctrl-d */
	pNewtio->c_cc[VTIME] = 5; /* inter-character timer, timeout VTIME*0.1 */
	pNewtio->c_cc[VMIN] = 0; /* blocking read until VMIN character arrives */
	pNewtio->c_cc[VSWTC] = 0; /* '\0' */
	pNewtio->c_cc[VSTART] = 0; /* Ctrl-q */
	pNewtio->c_cc[VSTOP] = 0; /* Ctrl-s */
	pNewtio->c_cc[VSUSP] = 0; /* Ctrl-z */
	pNewtio->c_cc[VEOL] = 0; /* '\0' */
	pNewtio->c_cc[VREPRINT] = 0; /* Ctrl-r */
	pNewtio->c_cc[VDISCARD] = 0; /* Ctrl-u */
	pNewtio->c_cc[VWERASE] = 0; /* Ctrl-w */
	pNewtio->c_cc[VLNEXT] = 0; /* Ctrl-v */
	pNewtio->c_cc[VEOL2] = 0; /* '\0' */
}

JNIEXPORT jint JNICALL 
Java_cn_geomobile_lfrfid_serial_1native_open_1serial(JNIEnv *env, jobject obj, jstring port)
{
	int fd;
	jboolean iscopy;
	struct termios oldtio, newtio;
	const char *dev = (*env)->GetStringUTFChars(env, port, &iscopy);;
	fd = open(dev, O_RDWR | O_NOCTTY);
	LOGD("now open %s\n", dev);
	(*env)->ReleaseStringUTFChars(env, port, dev);
	if(fd < 0)
	{
		LOGE("open serial port failed\n");
		LOGE("reason is %s\n", strerror(errno));
		return -1;
	}
	tcgetattr(fd, &oldtio); /* save current serial port settings */
//	setTermios(&newtio, B230400);
//	setTermios(&newtio, B115200);
	setTermios(&newtio, B9600);
	tcflush(fd, TCIFLUSH);
	tcsetattr(fd, TCSANOW, &newtio);
	LOGD("open serial port ok\n");
	return fd;
}

JNIEXPORT void JNICALL 
Java_cn_geomobile_lfrfid_serial_1native_close_1serial(JNIEnv *env, jobject obj, jint fd)
{
	close(fd);
	LOGD("close serial port ok\n");
}

JNIEXPORT jint JNICALL
Java_cn_geomobile_lfrfid_serial_1native_try_1write(JNIEnv *env, jobject obj , jint fd, jbyteArray content)
{
	int reval = 0, writed = 0, count = 0;
	char *buf = (*env)->GetByteArrayElements(env, content, 0);
	count = (*env)->GetArrayLength(env, content);
	tcflush(fd, TCIOFLUSH);
	do
	{
		reval = write(fd, buf + writed, count - writed);
		if(reval < 0)
		{
			LOGE("write serial port error\n");
			LOGE("reason is %s\n", strerror(errno));
			(*env)->ReleaseByteArrayElements(env, content, buf, 0);
			return -1;
		}
		writed += reval;
		LOGD("write %d of %d chars\n", writed, count);
	}
	while(writed < count);
	(*env)->ReleaseByteArrayElements(env, content, buf, 0);
	return 0;
}

JNIEXPORT jbyteArray JNICALL 
Java_cn_geomobile_lfrfid_serial_1native_try_1read(JNIEnv *env, jobject obj, jint fd, jint count, jint delay)
{
	int reval = 0, readed = 0;
	struct timeval tv;
	fd_set rfds;
	jbyteArray jba;
	char *buf = malloc(count);
	do
	{
		FD_ZERO(&rfds);
		FD_SET(fd, &rfds);
		tv.tv_sec = 0;
		tv.tv_usec = delay * 1000;
		if((reval = select(1 + fd, &rfds, NULL, NULL, &tv)) > 0)
		{
			if(FD_ISSET(fd, &rfds))
			{
				int temp = read(fd, buf + readed, count - readed);
				if(temp < 0)
				{
					LOGE("read serial error\n");
					LOGE("reason is %s\n", strerror(errno));
					free(buf);
					return NULL;
				}
				readed += temp;
				LOGD("%i us is used", delay * 1000 - tv.tv_usec);
				LOGD("read %d of %d chars\n", readed, count);
			}
		}
		else if(reval == 0 && readed != 0)			//timeout means 
		{
			break;
		}
		else
		{
			free(buf);
			return NULL;
		}
	}
	while(readed < count);
	jba = (*env)->NewByteArray(env, readed);
	(*env)->SetByteArrayRegion(env, jba, 0, readed, buf);
	free(buf);
	return jba;
}

JNIEXPORT void JNICALL 
Java_cn_geomobile_lfrfid_serial_1native_drop_1data(JNIEnv *env, jobject obj, jint fd)
{
	tcflush(fd, TCIOFLUSH);
}

